local TH, C, L = unpack(select(2, ...))
local MODULE_NAME = "PartyStatusText.lua"


local function configureHealthManaUpdates(frame)
    local textureframe = _G[frame:GetName().."Texture"]:GetParent()

    -- Create healthbar fontstrings
    local healthBarText = textureframe:CreateFontString(frame:GetName().."HealthBarText", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    healthBarText:SetPoint("CENTER", frame.healthbar, "CENTER", 0, 0)

    frame.healthbar.LeftText = textureframe:CreateFontString(frame:GetName().."HealthBarTextLeft", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    frame.healthbar.LeftText:SetPoint("LEFT", frame.healthbar, "LEFT", 0, 0)

    frame.healthbar.RightText = textureframe:CreateFontString(frame:GetName().."HealthBarTextRight", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    frame.healthbar.RightText:SetPoint("RIGHT", frame.healthbar, "RIGHT", 0, 0)

    -- Create manabar fontstrings
    local manaBarText = textureframe:CreateFontString(frame:GetName().."ManaBarText", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    manaBarText:SetPoint("CENTER", frame.manabar, "CENTER", 0, 0)

    frame.manabar.LeftText = textureframe:CreateFontString(frame:GetName().."ManaBarTextLeft", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    frame.manabar.LeftText:SetPoint("LEFT", frame.manabar, "LEFT", 0, 0)

    frame.manabar.RightText = textureframe:CreateFontString(frame:GetName().."ManaBarTextRight", "OVERLAY", "TargetHealth_TextStatusBarText_Small")
    frame.manabar.RightText:SetPoint("RIGHT", frame.manabar, "RIGHT", 0, 0)

    -- Initialize updates
    UnitFrameHealthBar_Initialize(frame.unit, frame.healthbar, healthBarText, true)
    UnitFrameManaBar_Initialize(frame.unit, frame.manabar, manaBarText, true)
end

---------------------------------------------
-- INITIALIZE
---------------------------------------------
TH.RegisterCallback(MODULE_NAME, "initialize", function()
    configureHealthManaUpdates(PartyMemberFrame1)
    configureHealthManaUpdates(PartyMemberFrame2)
    configureHealthManaUpdates(PartyMemberFrame3)
    configureHealthManaUpdates(PartyMemberFrame4)
end)
